/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of SHA.xs. Do not edit this file, edit SHA.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SHA.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef SvPVbyte
	#if PERL_REVISION == 5 && PERL_VERSION < 8
		#undef SvPVbyte
		#define SvPVbyte(sv, lp) \
			(sv_utf8_downgrade((sv), 0), SvPV((sv), (lp)))
	#endif
#else
	#define SvPVbyte SvPV
#endif

#include "src/sha.c"

static int ix2alg[] =
	{1,1,1,224,224,224,256,256,256,384,384,384,512,512,512,
	512224,512224,512224,512256,512256,512256};

#line 31 "SHA.c"
#ifndef INT2PTR
#define INT2PTR(p, i) (p) (i)
#endif
#define MAX_WRITE_SIZE 16384
XS(XS_Digest__SHA_shaclose); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_shaclose)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::shaclose(s)");
    {
	SHA *	s;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "SHAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    s = INT2PTR(SHA *,tmp);
	}
	else
	    Perl_croak(aTHX_ "s is not of type SHAPtr");
#line 35 "SHA.xs"
	RETVAL = shaclose(s);
	sv_setiv(SvRV(ST(0)), 0);
#line 56 "SHA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA_shadup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_shadup)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::shadup(s)");
    {
	SHA *	s;
	SHA *	RETVAL;

	if (sv_derived_from(ST(0), "SHAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    s = INT2PTR(SHA *,tmp);
	}
	else
	    Perl_croak(aTHX_ "s is not of type SHAPtr");

	RETVAL = shadup(s);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "SHAPtr", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA_shaopen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_shaopen)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::shaopen(alg)");
    {
	int	alg = (int)SvIV(ST(0));
	SHA *	RETVAL;

	RETVAL = shaopen(alg);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "SHAPtr", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA_sharewind); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_sharewind)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::sharewind(s)");
    {
	SHA *	s;

	if (sv_derived_from(ST(0), "SHAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    s = INT2PTR(SHA *,tmp);
	}
	else
	    Perl_croak(aTHX_ "s is not of type SHAPtr");

	sharewind(s);
    }
    XSRETURN_EMPTY;
}

XS(XS_Digest__SHA_shawrite); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_shawrite)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Digest::SHA::shawrite(bitstr, bitcnt, s)");
    {
	unsigned char *	bitstr = (unsigned char *)SvPV_nolen(ST(0));
	unsigned long	bitcnt = (unsigned long)SvUV(ST(1));
	SHA *	s;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(2), "SHAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    s = INT2PTR(SHA *,tmp);
	}
	else
	    Perl_croak(aTHX_ "s is not of type SHAPtr");

	RETVAL = shawrite(bitstr, bitcnt, s);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA_sha1); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_sha1)
{
    dXSARGS;
    dXSI32;
   PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 83 "SHA.xs"
	int i;
	UCHR *data;
	STRLEN len;
	SHA *state;
	char *result;
#line 164 "SHA.c"
#line 89 "SHA.xs"
	if ((state = shaopen(ix2alg[ix])) == NULL)
		XSRETURN_UNDEF;
	for (i = 0; i < items; i++) {
		data = (UCHR *) (SvPVbyte(ST(i), len));
		while (len > MAX_WRITE_SIZE) {
			shawrite(data, MAX_WRITE_SIZE << 3, state);
			data += MAX_WRITE_SIZE;
			len  -= MAX_WRITE_SIZE;
		}
		shawrite(data, len << 3, state);
	}
	shafinish(state);
	len = 0;
	if (ix % 3 == 0) {
		result = (char *) digcpy(state);
		len = state->digestlen;
	}
	else if (ix % 3 == 1)
		result = shahex(state);
	else
		result = shabase64(state);
	ST(0) = sv_2mortal(newSVpv(result, len));
	shaclose(state);
	XSRETURN(1);
#line 190 "SHA.c"
	PUTBACK;
	return;
    }
}

XS(XS_Digest__SHA_hmac_sha1); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_hmac_sha1)
{
    dXSARGS;
    dXSI32;
   PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 139 "SHA.xs"
	int i;
	UCHR *key;
	UCHR *data;
	STRLEN len;
	HMAC *state;
	char *result;
#line 211 "SHA.c"
#line 146 "SHA.xs"
	key = (UCHR *) (SvPVbyte(ST(items-1), len));
	if ((state = hmacopen(ix2alg[ix], key, len)) == NULL)
		XSRETURN_UNDEF;
	for (i = 0; i < items - 1; i++) {
		data = (UCHR *) (SvPVbyte(ST(i), len));
		while (len > MAX_WRITE_SIZE) {
			hmacwrite(data, MAX_WRITE_SIZE << 3, state);
			data += MAX_WRITE_SIZE;
			len  -= MAX_WRITE_SIZE;
		}
		hmacwrite(data, len << 3, state);
	}
	hmacfinish(state);
	len = 0;
	if (ix % 3 == 0) {
		result = (char *) digcpy(state->osha);
		len = state->osha->digestlen;
	}
	else if (ix % 3 == 1)
		result = hmachex(state);
	else
		result = hmacbase64(state);
	ST(0) = sv_2mortal(newSVpv(result, len));
	hmacclose(state);
	XSRETURN(1);
#line 238 "SHA.c"
	PUTBACK;
	return;
    }
}

XS(XS_Digest__SHA_hashsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_hashsize)
{
    dXSARGS;
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(self)", GvNAME(CvGV(cv)));
    SP -= items;
    {
	SV *	self = ST(0);
#line 179 "SHA.xs"
	SHA *state;
	int result;
#line 257 "SHA.c"
#line 182 "SHA.xs"
	if (!sv_isa(self, "Digest::SHA"))
		XSRETURN_UNDEF;
	state = INT2PTR(SHA *, SvIV(SvRV(SvRV(self))));
	result = ix ? state->alg : state->digestlen << 3;
	ST(0) = sv_2mortal(newSViv(result));
	XSRETURN(1);
#line 265 "SHA.c"
	PUTBACK;
	return;
    }
}

XS(XS_Digest__SHA_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_add)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::add(self, ...)");
    SP -= items;
    {
	SV *	self = ST(0);
#line 193 "SHA.xs"
	int i;
	UCHR *data;
	STRLEN len;
	SHA *state;
#line 285 "SHA.c"
#line 198 "SHA.xs"
	if (!sv_isa(self, "Digest::SHA"))
		XSRETURN_UNDEF;
	state = INT2PTR(SHA *, SvIV(SvRV(SvRV(self))));
	for (i = 1; i < items; i++) {
		data = (UCHR *) (SvPVbyte(ST(i), len));
		while (len > MAX_WRITE_SIZE) {
			shawrite(data, MAX_WRITE_SIZE << 3, state);
			data += MAX_WRITE_SIZE;
			len  -= MAX_WRITE_SIZE;
		}
		shawrite(data, len << 3, state);
	}
	XSRETURN(1);
#line 300 "SHA.c"
	PUTBACK;
	return;
    }
}

XS(XS_Digest__SHA_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA_digest)
{
    dXSARGS;
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(self)", GvNAME(CvGV(cv)));
    SP -= items;
    {
	SV *	self = ST(0);
#line 220 "SHA.xs"
	STRLEN len;
	SHA *state;
	char *result;
#line 320 "SHA.c"
#line 224 "SHA.xs"
	if (!sv_isa(self, "Digest::SHA"))
		XSRETURN_UNDEF;
	state = INT2PTR(SHA *, SvIV(SvRV(SvRV(self))));
	shafinish(state);
	len = 0;
	if (ix == 0) {
		result = (char *) digcpy(state);
		len = state->digestlen;
	}
	else if (ix == 1)
		result = shahex(state);
	else
		result = shabase64(state);
	ST(0) = sv_2mortal(newSVpv(result, len));
	sharewind(state);
	XSRETURN(1);
#line 338 "SHA.c"
	PUTBACK;
	return;
    }
}

XS(XS_Digest__SHA__getstate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA__getstate)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::_getstate(self)");
    SP -= items;
    {
	SV *	self = ST(0);
#line 245 "SHA.xs"
	SHA *state;
	UCHR buf[256];
	UCHR *ptr = buf;
#line 357 "SHA.c"
#line 249 "SHA.xs"
	if (!sv_isa(self, "Digest::SHA"))
		XSRETURN_UNDEF;
	state = INT2PTR(SHA *, SvIV(SvRV(SvRV(self))));
	memcpy(ptr, digcpy(state), state->alg <= SHA256 ? 32 : 64);
	ptr += state->alg <= SHA256 ? 32 : 64;
	memcpy(ptr, state->block, state->alg <= SHA256 ? 64 : 128);
	ptr += state->alg <= SHA256 ? 64 : 128;
	ptr = w32mem(ptr, state->blockcnt);
	ptr = w32mem(ptr, state->lenhh);
	ptr = w32mem(ptr, state->lenhl);
	ptr = w32mem(ptr, state->lenlh);
	ptr = w32mem(ptr, state->lenll);
	ST(0) = sv_2mortal(newSVpv((char *) buf, ptr - buf));
	XSRETURN(1);
#line 373 "SHA.c"
	PUTBACK;
	return;
    }
}

XS(XS_Digest__SHA__putstate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA__putstate)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA::_putstate(self, ...)");
    SP -= items;
    {
	SV *	self = ST(0);
#line 268 "SHA.xs"
	UINT bc;
	STRLEN len;
	SHA *state;
	UCHR *data;
#line 393 "SHA.c"
#line 273 "SHA.xs"
	if (!sv_isa(self, "Digest::SHA"))
		XSRETURN_UNDEF;
	state = INT2PTR(SHA *, SvIV(SvRV(SvRV(self))));
	data = (UCHR *) SvPV(ST(1), len);
	if (len != (state->alg <= SHA256 ? 116 : 212))
		XSRETURN_UNDEF;
	data = statecpy(state, data);
	memcpy(state->block, data, state->blocksize >> 3);
	data += (state->blocksize >> 3);
	bc = memw32(data), data += 4;
	if (bc >= (state->alg <= SHA256 ? 512 : 1024))
		XSRETURN_UNDEF;
	state->blockcnt = bc;
	state->lenhh = memw32(data), data += 4;
	state->lenhl = memw32(data), data += 4;
	state->lenlh = memw32(data), data += 4;
	state->lenll = memw32(data);
	XSRETURN(1);
#line 413 "SHA.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Digest__SHA); /* prototype to pass -Wmissing-prototypes */
XS(boot_Digest__SHA)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("Digest::SHA::shaclose", XS_Digest__SHA_shaclose, file, "$");
        newXSproto("Digest::SHA::shadup", XS_Digest__SHA_shadup, file, "$");
        newXSproto("Digest::SHA::shaopen", XS_Digest__SHA_shaopen, file, "$");
        newXSproto("Digest::SHA::sharewind", XS_Digest__SHA_sharewind, file, "$");
        newXSproto("Digest::SHA::shawrite", XS_Digest__SHA_shawrite, file, "$$$");
        cv = newXS("Digest::SHA::sha512_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 13 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 14 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha224", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 3 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha256_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 7 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha384_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 10 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 12 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512224", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 15 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha1_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha256", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 6 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha384_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 11 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha1_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 2 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha224_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 4 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512224_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 16 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512256_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 20 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha384", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 9 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha256_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 8 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha224_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 5 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha1", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512256", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 18 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512224_base64", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 17 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::sha512256_hex", XS_Digest__SHA_sha1, file);
        XSANY.any_i32 = 19 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha1_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 2 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha1", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha1_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha224", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 3 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512224_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 17 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha384_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 10 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 14 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512224_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 16 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha256_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 7 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512224", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 15 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 12 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512256", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 18 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha256", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 6 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512256_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 19 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha224_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 4 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha384", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 9 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha256_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 8 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha384_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 11 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha224_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 5 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512256_base64", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 20 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::hmac_sha512_hex", XS_Digest__SHA_hmac_sha1, file);
        XSANY.any_i32 = 13 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Digest::SHA::algorithm", XS_Digest__SHA_hashsize, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("Digest::SHA::hashsize", XS_Digest__SHA_hashsize, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        newXSproto("Digest::SHA::add", XS_Digest__SHA_add, file, "$;@");
        cv = newXS("Digest::SHA::digest", XS_Digest__SHA_digest, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("Digest::SHA::Hexdigest", XS_Digest__SHA_digest, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("Digest::SHA::B64digest", XS_Digest__SHA_digest, file);
        XSANY.any_i32 = 2 ;
        sv_setpv((SV*)cv, "$") ;
        newXSproto("Digest::SHA::_getstate", XS_Digest__SHA__getstate, file, "$");
        newXSproto("Digest::SHA::_putstate", XS_Digest__SHA__putstate, file, "$;@");
    }
    XSRETURN_YES;
}

